#!/bin/bash
#
# Last update: 2024.6.3

# 安裝 CXS 與 其餘套件

# ConfigServer eXploit Scanner
cd /usr/local/src/
wget https://download.configserver.com/cxsinstaller.tgz
tar -xzf cxsinstaller.tgz
perl cxsinstaller.pl
rm -Rfv /usr/local/src/cxsinstaller.*

# ConfigServer ModSecurity Control
cd /usr/local/src/
wget http://download.configserver.com/cmc.tgz
tar -xzf cmc.tgz
cd cmc
sh install.sh
rm -Rfv /usr/local/src/cmc*

# ConfigServer Explorer
cd /usr/local/src/
wget https://download.configserver.com/cse.tgz
tar -xzf cse.tgz
cd cse
sh install.sh
rm -Rfv /usr/local/src/cse*

# ConfigServer Mail Queues
cd /usr/local/src/
wget http://download.configserver.com/cmq.tgz
tar -xzf cmq.tgz
cd cmq
sh install.sh
rm -Rfv /usr/local/src/cmq*

# ConfigServer Mail Manage
cd /usr/local/src/
wget http://download.configserver.com/cmm.tgz
tar -xzf cmm.tgz
cd cmm
sh install.sh
rm -Rfv /usr/local/src/cmm*

# 建立暫存目錄

mkdir -p /backup/cxs_upload
chmod 777 /backup/cxs_upload

# 新增 cxs.ignore 與 cxs.template 範例檔案

rm -f /etc/cxs/cxs.ignore
rm -f /etc/cxs/cxs.template
cp /etc/cxs/cxs.ignore.example /etc/cxs/cxs.ignore
cp /etc/cxs/cxs.template.example /etc/cxs/cxs.template

# 安裝所需套件

/scripts/perlinstaller Linux::Inotify2

# 新增 cxs.log 與 cxs.scan 檔案

touch /var/log/cxs.log
touch /var/log/cxs.scan
chown root:nobody /var/log/cxs.log
chown root:nobody /var/log/cxs.scan
chmod 666 /var/log/cxs.log
chmod 666 /var/log/cxs.scan

# 將 cxs 排程加入 /etc/cron.daily

ln -s /etc/cxs/cxsdaily.sh /etc/cron.daily/

# 調整 /etc/cxs/cxs.template 權限，與編輯設定檔

mv /etc/cxs/cxs.template /etc/cxs/cxs.template_bak
touch /etc/cxs/cxs.template
chmod 644 /etc/cxs/cxs.template
cat << EOF > /etc/cxs/cxs.template
From: [from]
To: [to]
CC: [user]
Subject: cxs Scan on [hostname] (Hits:[hits]) (Viruses:[viruses]) (Fingerprints:[fingerprints])

Time        : [time]
User Contact: [user]

The following has been reported by the ConfigServer eXploit Scanner running on [hostname]:

[text]
EOF

# 安裝 ClamAV

/scripts/update_local_rpm_versions --edit target_settings.clamav installed
#/scripts/check_cpanel_rpms --fix --targets=clamav
/scripts/check_cpanel_pkgs --fix --targets=clamav

# 關閉 cxswatch 服務

systemctl stop cxswatch.service
systemctl disable cxswatch.service
mv /etc/cxs/cxswatch.sh /etc/cxs/cxswatch.sh_bak
#mv /etc/cxs/cxsftp.sh /etc/cxs/cxsftp.sh_bak


